#!/usr/bin/env pythonw   # mac specific
# FIX: put some documentation here!

import wx
#import ais_msg_1	# FIX: turn this back on


testParams = {'COG': 34.5,
 'MessageID': 1,
 'NavigationStatus': 3,
 'PositionAccuracy': 1,
 'Position_latitude': 37.424458333333334,
 'Position_longitude': -122.16328055555556,
 'RAIM': False,
 'ROT': -2,
 'RegionalReserved': 0,
 'RepeatIndicator': 1,
 'SOG': 101.9,
 'Spare': 0,
 'TimeStamp': 35,
 'TrueHeading': 41,
 'UserID': 1193046,
 'slotoffset': 1221,
 'syncstate': 2}

class MsgFrame(wx.Frame):
	'''
	# FIX: write doc string here for the frame
	''' 

	RepeatIndicatorList = [
		'0 - default',
		'1',
		'2',
		'3 - do not repeat any more',
		]
	NavigationStatusList = [
		'0 - under way using engine',
		'1 - at anchor',
		'2 - not under command',
		'3 - restricted maneuverability',
		'4 - constrained by her draught',
		'5 - moored',
		'6 - aground',
		'7 - engaged in fishing',
		'8 - under way sailing',
		'9 - reserved for future use (hazmat)',
		'10 - reserved for future use',
		'11 - reserved for future use',
		'12 - reserved for future use',
		'13 - reserved for future use',
		'14 - reserved for future use',
		'15 - not defined = default',
		]
	PositionAccuracyList = [
		'0 - low (greater than 10 m)',
		'1 - high (less than 10 m)',
		]
	syncstateList = [
		'0 - UTC direct',
		'1 - UTC indirect',
		'2 - synchronized to a base station',
		'3 - synchronized to another station',
		]
	BoolList=['False','True']

	def __init__(self,parent,title,msgDict):
		'''
		@param msgDict: Default values to use.
			Overwritten with the return values.
			Values that are required will be ignored.
		@type msgDict: dict
		'''
		wx.Frame.__init__(self,parent,-1,title,size=(640,480)) # FIX: what size?
		self.msgDict = msgDict # Save this so we can edit and return valies in the incoming dict

		defaults = testParams # FIX: turn off this hack and use the unavailable values

		sizer=wx.FlexGridSizer(rows=1,cols=2, vgap=13, hgap=13)
		sizer.AddGrowableCol(1)
		self.SetSizer(sizer)


		############################ Field MessageID - uint
		txt = wx.StaticText(self,label='MessageID')
		self.MessageIDWidget=wx.StaticText(self,label='1')

		sizer.Add(item=txt); del txt
		sizer.Add(self.MessageIDWidget,flag=wx.EXPAND)

		############################ Field RepeatIndicator - uint
		txt = wx.StaticText(self,label='RepeatIndicator')
		value=str(defaults['RepeatIndicator'])
		if 'RepeatIndicator' in msgDict: value = str(msgDict['RepeatIndicator'])
		self.RepeatIndicatorWidget=wx.Choice(self,-1, choices = self.RepeatIndicatorList)
		self.RepeatIndicatorWidget.SetSelection(int(value))
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.RepeatIndicatorWidget,flag=wx.EXPAND)

		############################ Field UserID - uint
		txt = wx.StaticText(self,label='UserID')
		value=str(defaults['UserID'])
		if 'UserID' in msgDict: value = str(msgDict['UserID'])
		self.UserIDWidget=wx.SpinCtrl(self,value=value,min=0,max=1073741823)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.UserIDWidget,flag=wx.EXPAND)

		############################ Field NavigationStatus - uint
		txt = wx.StaticText(self,label='NavigationStatus')
		value=str(defaults['NavigationStatus'])
		if 'NavigationStatus' in msgDict: value = str(msgDict['NavigationStatus'])
		self.NavigationStatusWidget=wx.Choice(self,-1, choices = self.NavigationStatusList)
		self.NavigationStatusWidget.SetSelection(int(value))
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.NavigationStatusWidget,flag=wx.EXPAND)

		############################ Field ROT - int
		txt = wx.StaticText(self,label='ROT')
		value=str(defaults['ROT'])
		if 'ROT' in msgDict: value = str(msgDict['ROT'])
		self.ROTWidget=wx.SpinCtrl(self,value=value,min=128,max=127)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.ROTWidget,flag=wx.EXPAND)

		############################ Field SOG - udecimal
		txt = wx.StaticText(self,label='SOG')
		value=str(defaults['SOG'])
		if 'SOG' in msgDict: value = str(msgDict['SOG'])
		self.SOGWidget=wx.Slider(self,-1,float(value),0,102.3,style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS | wx.SL_LABELS)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.SOGWidget,flag=wx.EXPAND)

		############################ Field PositionAccuracy - uint
		txt = wx.StaticText(self,label='PositionAccuracy')
		value=str(defaults['PositionAccuracy'])
		if 'PositionAccuracy' in msgDict: value = str(msgDict['PositionAccuracy'])
		self.PositionAccuracyWidget=wx.Choice(self,-1, choices = self.PositionAccuracyList)
		self.PositionAccuracyWidget.SetSelection(int(value))
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.PositionAccuracyWidget,flag=wx.EXPAND)

		############################ Field Position_longitude - decimal
		txt = wx.StaticText(self,label='Position_longitude')
		value=str(defaults['Position_longitude'])
		if 'Position_longitude' in msgDict: value = str(msgDict['Position_longitude'])
		self.Position_longitudeWidget=wx.Slider(self,-1,float(value),-180.0,181.0,style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS | wx.SL_LABELS)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.Position_longitudeWidget,flag=wx.EXPAND)

		############################ Field Position_latitude - decimal
		txt = wx.StaticText(self,label='Position_latitude')
		value=str(defaults['Position_latitude'])
		if 'Position_latitude' in msgDict: value = str(msgDict['Position_latitude'])
		self.Position_latitudeWidget=wx.Slider(self,-1,float(value),-90.0,91.0,style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS | wx.SL_LABELS)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.Position_latitudeWidget,flag=wx.EXPAND)

		############################ Field COG - udecimal
		txt = wx.StaticText(self,label='COG')
		value=str(defaults['COG'])
		if 'COG' in msgDict: value = str(msgDict['COG'])
		self.COGWidget=wx.Slider(self,-1,float(value),0,409.5,style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS | wx.SL_LABELS)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.COGWidget,flag=wx.EXPAND)

		############################ Field TrueHeading - uint
		txt = wx.StaticText(self,label='TrueHeading')
		value=str(defaults['TrueHeading'])
		if 'TrueHeading' in msgDict: value = str(msgDict['TrueHeading'])
		self.TrueHeadingWidget=wx.SpinCtrl(self,value=value,min=0,max=511)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.TrueHeadingWidget,flag=wx.EXPAND)

		############################ Field TimeStamp - uint
		txt = wx.StaticText(self,label='TimeStamp')
		value=str(defaults['TimeStamp'])
		if 'TimeStamp' in msgDict: value = str(msgDict['TimeStamp'])
		self.TimeStampWidget=wx.SpinCtrl(self,value=value,min=0,max=63)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.TimeStampWidget,flag=wx.EXPAND)

		############################ Field RegionalReserved - uint
		txt = wx.StaticText(self,label='RegionalReserved')
		self.RegionalReservedWidget=wx.StaticText(self,label='0')

		sizer.Add(item=txt); del txt
		sizer.Add(self.RegionalReservedWidget,flag=wx.EXPAND)

		############################ Field Spare - uint
		txt = wx.StaticText(self,label='Spare')
		self.SpareWidget=wx.StaticText(self,label='0')

		sizer.Add(item=txt); del txt
		sizer.Add(self.SpareWidget,flag=wx.EXPAND)

		############################ Field RAIM - bool
		txt = wx.StaticText(self,label='RAIM')
		value=str(defaults['RAIM'])
		if 'RAIM' in msgDict: value = str(msgDict['RAIM'])
		self.RAIMWidget=wx.Choice(self,-1, choices = self.BoolList)
		if defaults['RAIM']: self.RAIMWidget.SetSelection(1)
		else:  self.RAIMWidget.SetSelection(0)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.RAIMWidget,flag=wx.EXPAND)

		############################ Field syncstate - uint
		txt = wx.StaticText(self,label='syncstate')
		value=str(defaults['syncstate'])
		if 'syncstate' in msgDict: value = str(msgDict['syncstate'])
		self.syncstateWidget=wx.Choice(self,-1, choices = self.syncstateList)
		self.syncstateWidget.SetSelection(int(value))
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.syncstateWidget,flag=wx.EXPAND)

		############################ Field slotoffset - uint
		txt = wx.StaticText(self,label='slotoffset')
		value=str(defaults['slotoffset'])
		if 'slotoffset' in msgDict: value = str(msgDict['slotoffset'])
		self.slotoffsetWidget=wx.SpinCtrl(self,value=value,min=0,max=16383)
		del value

		sizer.Add(item=txt); del txt
		sizer.Add(self.slotoffsetWidget,flag=wx.EXPAND)

    		#######
    		#######  FINISH UP __init__
    		#######
		btnDone = wx.Button(self,label='Done')
	
		sizer.Add((1,35),0,wx.ADJUST_MINSIZE,0)
		sizer.Add(item=btnDone)
		btnDone.Bind(wx.EVT_BUTTON,self.OnDone)

		self.Layout() # Get yourself organized
		self.Show()

	def OnDone(self,evt):
        	'''
		Put all values into msgDict so that they get returned to the caller
		'''
		self.msgDict['MessageID']=1
		self.msgDict['RepeatIndicator']=self.RepeatIndicatorWidget.GetSelection()
		self.msgDict['UserID']=self.UserIDWidget.GetValue()
		self.msgDict['NavigationStatus']=self.NavigationStatusWidget.GetSelection()
		self.msgDict['ROT']=self.ROTWidget.GetValue()
		self.msgDict['SOG']=self.SOGWidget.GetValue()
		self.msgDict['PositionAccuracy']=self.PositionAccuracyWidget.GetSelection()
		self.msgDict['Position_longitude']=self.Position_longitudeWidget.GetValue()
		self.msgDict['Position_latitude']=self.Position_latitudeWidget.GetValue()
		self.msgDict['COG']=self.COGWidget.GetValue()
		self.msgDict['TrueHeading']=self.TrueHeadingWidget.GetValue()
		self.msgDict['TimeStamp']=self.TimeStampWidget.GetValue()
		self.msgDict['RegionalReserved']=0
		self.msgDict['Spare']=0
		self.msgDict['RAIM']=self.RAIMWidget.GetSelection()
		self.msgDict['syncstate']=self.syncstateWidget.GetSelection()
		self.msgDict['slotoffset']=self.slotoffsetWidget.GetValue()
		self.Close(True)

if __name__=='__main__':
	app = wx.PySimpleApp()
	theData={}
	frame = MsgFrame(None,'Position Message Editor',theData)
	app.MainLoop()

	print 'finishing up', theData
